#ifndef CENEMY_H
#define CENEMY_H

#include <SDL.h>
#include "CGameObject.h"
#include "CSinCosTable.h"
#include "Functions.h"
#include "CWorldParts.h"

extern SDL_Surface *IMGExplosion;

class CEnemy : CGameObject
{
    private:
        int PMovementType,PHitPoints,PVisibleSwaps;
        void  Move();
    public:
        void DecHitPoints();
        int GetHitPoints() {return PHitPoints;}
        int GetMovementType() {return PMovementType;}
        CEnemy(CSurfaceRotationCache *ImgIn, int Xin, int Yin, int MovementType, double Speed, int HitPoints,int ZOrder, CSinCosTable *SinCosTableIn) : CGameObject(ImgIn, Xin, Yin,0,0, Speed,ZOrder , SinCosTableIn)
        {
            PType = 3;
            PMovementType = MovementType;
            PHitPoints = HitPoints;
            PVisibleSwaps = 0;
            switch(PMovementType)
            {
                case 1:
                    PAngle = 90;
                    DisplayAngle = 90;
                    PAngleInc = 3;
                    break;
                case 2:
                    PAngle = 90;
                    DisplayAngle = 180;
                    PAngleInc = -2;
                    break;
                case 3:
                    PAngle = 90;
                    DisplayAngle = 180;
                    PAngleInc = 2;
                    break;
            }
        }

};

#endif
